#include <time.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

struct point {
	int x;
	int y;
};

int distance_point_point(struct point *p1, struct point *p2) {
	return sqrt( pow( p1->x - p2->x, 2) + pow( p1->y - p2->y, 2) );
}

int main(int argc, char** argv) {
	int size_x = 500;
	int size_y = 500;
	unsigned char *block = malloc( size_x * size_y );
	struct point refp; refp.x = 200; refp.y = 200;

	clock_t begin = clock();

	struct point p;
	int i,j, dist;
	for (j=0; j< size_y; j++) {
		for (i=0; i< size_x; i++) {
			p.x = i;
			p.y = j;
			dist = distance_point_point(&p, &refp);
			if ( dist > 255 ) {
				block[i*j] = 255;
			} else {
				block[i*j] = dist;
			}
		}
	}

	clock_t end = clock();

	printf("Time: %f\n", (end-begin)/(double)CLOCKS_PER_SEC );

	if (block) {
		free(block);
		block = 0;
	}

	return 0;
}
